﻿<h1 id="bpduguard-and-root-guard">BPDUGuard and Root Guard</h1>
<h3 id="--the-spanning-tree-protocol-is-a-layer-2-control-plane-protocol-that-prevents-switching-loops-by-electing-a-root-bridge-and-placing-switchport-into-a-forwarding-or-blocking-state-cisco-switches-will-send-bridge-protocol-datagram-units-per-vlan-to-elect-a-root-switch-which-all-other-switches-will-forward-traffic-too">- The spanning-tree protocol is a Layer 2 Control plane protocol that prevents switching loops by electing a root bridge and placing switchport into a Forwarding or blocking state. Cisco switches will send Bridge Protocol Datagram Units per VLAN to elect a root switch, which all other switches will forward traffic too.</h3>
<h3 id="--stp-is-also-vulnerable-to-layer-2-attacks-like-superior-bdpus-and-malicious-users-creating-a-broadcast-storm-by-flooding-the-switched-architecture-with-bpdus">- STP is also vulnerable to Layer 2 attacks like Superior BDPU's, and malicious users creating a broadcast storm by flooding the switched architecture with BPDU's.</h3>
<h3 id="--rootguard-will-prevent-the-manipulation-of-root-bridge-elections-by-placing-protecting-the-root-bridge-from-receiving-superior-bpdus">- Rootguard will prevent the manipulation of root bridge elections by placing protecting the root bridge from receiving superior BPDU's.</h3>
<p><img src="layer_2_security_network_diagram.png" alt="" /></p>
<h3 id="--for-this-how-to-we-will-configure-rootguard-on-the-root-switches-trunk-ports">- For this How To we will configure rootguard on the root switches trunk ports.</h3>
<p><code>SW3(config)#interface range eth0/1 - 2</code> # This command brings you into the sub-configuration mode for a range of interfaces.</p>
<p><code>SW3(config-if-range)#spanning-tree guard root</code> # This command will place a designated port on the root bridge into a &quot;blocking&quot; state</p>
<h3 id="--verification-now-lets-see-what-happens-to-our-topology-once-we-apply-rootguard-and-attempt-to-send-a-superior-bpdu-to-sw3">- Verification. Now lets see what happens to our topology once we apply rootguard and attempt to send a superior BPDU to SW3</h3>
<p><img src="show_spanning_tree_vlan_10.png" alt="" /></p>
<h3 id="--as-you-can-see-here-sw3-is-the-rootbridge-for-vlan-we-have-already-configured-rootguard-now-lets-go-to-sw2-and-try-to-make-it-the-rootbridge-and-check-what-happens-on-sw3">- As you can see here SW3 is the rootbridge for VLAN. We have already configured rootguard. Now lets go to SW2 and try to make it the rootbridge and check what happens on SW3</h3>
<p><img src="spanning_tree_vlan_10_priority_0.png" alt="" /></p>
<p><img src="show_spanning_tree_w_root_guard_enabled.png" alt="" /></p>
<h3 id="--as-you-can-see-now-the-two-interfaces-facing-the-other-switches-are-in-a-blocking-state-this-is-because-sw2-tried-to-send-a-superior-bpdu-to-sw3-from-sw1-and-from-itself">- As you can see now the two interfaces facing the other switches are in a blocking state. This is because SW2 tried to send a <strong>&quot;superior BPDU&quot;</strong> to SW3 from SW1 and from itself.</h3>
<h1 id="bpduguard">BPDUGuard</h1>
<h3 id="bpduguard-is-a-feature-we-apply-to-our-access-ports-to-prevent-the-interfaces-facing-our-users-from-processing-bpdus-this-protects-our-switched-architecture-from-bpdus-being-flooded-into-the-network">BPDUGuard is a feature we apply to our access ports to prevent the interfaces facing our users from processing BPDUs. This protects our switched architecture from BPDUs being flooded into the network.</h3>
<p><code>SW2(config)#interface range eth0/1, eth0/3</code> # This command brings you into the sub-configuration mode for a range of interfaces.</p>
<p><code>SW2(config-if-range)#spanning-tree bpduguard enable</code> # This command will place a port into an <strong>&quot;err-disabled&quot;</strong> state if the port receives a BPDU</p>
<h3 id="the-full-configuration-is-shown-below">The full configuration is shown below</h3>
<p><img src="spanning_tree_bpduguard_enable_config.png" alt="" /></p>
<h3 id="verification-now-lets-attach-a-switch-to-the-access-ports-and-see-how-they-respond-as-we-can-see-below-with-a-switch-connected-and-sending-bpdus-the-access-port-goes-into-a-err-disabled-state">Verification. Now let's attach a switch to the access ports and see how they respond. As we can see below with a switch connected and sending BPDU's the access port goes into a <strong>&quot;err-disabled&quot;</strong> state.</h3>
<p><img src="bpduguard_network_diagram.png" alt="" /></p>
<p><img src="show_int_eth0_3_err_dis.png" alt="" /></p>
<p><img src="show_int_status_err_disabled.png" alt="" /></p>
